public class NaturalLanguageMessageGenerator extends MessageGenerator
{
	public NaturalLanguageMessageGenerator(String[] args)
	{
		super(args);
	}

	public String getArgumentName(int argument)
	{
		return args[argument];
	}

	/**
	Returns the set of arguments used by this generator.
	@Return the set of arguments used by this generator
	*/
	public String[] getArgs()
	{
		return args;
	}

	public String getMessage(int type, int game, boolean proponent, int argument, int previous)
	{
		String msg = "";

		if (type == QUESTION_OUTPUT_G ||
			type == QUESTION_OUTPUT_NOTG_P ||
			type == QUESTION_OUTPUT_NOTP)
		{
			msg = "You asked me whether or not " + args[argument] + ".\n";

			switch (type)
			{
				case QUESTION_OUTPUT_G: 	 msg += "Well, I think it MUST be so!";
											 break;

				case QUESTION_OUTPUT_NOTG_P: msg += "Well, I think we can accept it, but we don't have to...";
											 break;

				case QUESTION_OUTPUT_NOTP: 	 msg += "Well, I don't think so!";
											 break;

				default: error();
			}
		}

		else if (type == USER_DISAGREE)
		{
			switch (game)
			{
				case GROUNDED_GAME:	 if (proponent)
										msg = "No, I think it doesn't HAVE to be accepted.";
									 else
									 	msg = "We HAVE to accept it!";
									 break;
				case PREFERRED_GAME: if (proponent)
										msg = "In my opinion you CAN'T accept it at all!";
									 else
									 	msg = "I think it can be, why not??";
									 break;
				default: error();
			}
		}

		else if (type == USER_ACCEPT)
			msg = "Ok, you're right";

		else if (type == START_DISCUSSION)
		{
			switch (game)
			{
				case GROUNDED_GAME:	 if (proponent)
										msg = "Ok, we can discuss... but I'm still on my position!";
									 else
									 	msg = "Really?? But "+ args[argument] + "...";
									 break;
				case PREFERRED_GAME: if (proponent)
										msg = "Ok... but I still think we can accept it!";
									 else
									 	msg = "Really?? But if you say so, then you don't agree with the fact that " + args[argument] + "...";
									 break;
				default: error();
			}
		}

		else if (type == USER_SURRENDER)
			msg = "Damn, you must be right!";

		else if (type == PLAYING_GAME)
		{
			switch (game)
			{
				case GROUNDED_GAME:	 if (proponent)
										msg = "It cannot be, because " + args[argument] + "!";
									 else
									 	msg = "But maybe " + args[argument] + ".";
									 break;
				case PREFERRED_GAME: if (proponent)
										msg = "No, because " + args[argument] + "!";
									 else
									 	msg = "Then you don't think that " + args[argument] + "?";
									 break;
				default: error();

			}

		}

		else if (type == GAME_OVER)
		{
			switch (game)
			{
				case GROUNDED_GAME:	 msg = "Now we're going in circle... I'm afraid you're not going to convince me!!";
									 break;
				case PREFERRED_GAME: if (proponent)
										msg = "You see, you cannot find arguments anymore!";
									 else
									 	msg = "Sorry dude, you're contradicting... sure you cannot convince me!";
									 break;
				default: error();
			}
		}

		else if (type == WRONG_MOVE)
		{
			switch (game)
			{
				case GROUNDED_GAME:	 msg = "Well, this point has already been explained, I think!!";
									 break;
				case PREFERRED_GAME: if (proponent)
										msg = "Again? I thought this point was already clear! Try something else!";
									 else
									 	msg = "This way you're contradicting, dude!";
									 break;
				default: error();
			}
		}

		else error();

		return msg;
	}

	private void error()
	{
		throw new IllegalArgumentException("The input for generating a message is wrong.");
	}
}