package argumentation;


/**
An ArgumentationFrameworkLoader loads an argumentation framework's data from
a source; i.e., being  AF(Args, Def), the set of arguments Args and the defeating
relation Def.
*/
public interface ArgumentationFrameworkLoader
{
	/**
	Returns the set of the names of the arguments. If the names of the arguments
	are not specified, the method should return null.
	@returns the set of the names of the arguments, or null if the names are not
	specified by the source.
	*/
	public String[] getArgs();

	/**
	Returns the defeating relation of the loaded argumentation framework.
	@returns the defeating relation of the loaded argumentation framework
	*/
	public boolean[][] getDef();
}